//+------------------------------------------------------------------+
//|                                                        3_RSI.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 100.0
#property indicator_buffers 3
#property indicator_level1 70
#property indicator_level2 50
#property indicator_level3 30

extern string PAR_1 = "EURUSD";
extern string PAR_2 = "USDJPY";
extern string PAR_3 = "EURJPY";

extern bool Mirroring_PAR_1 = false;
extern bool Mirroring_PAR_2 = false;
extern bool Mirroring_PAR_3 = false;

extern color Color_1=Lime;
extern color Color_2=Blue;
extern color Color_3=Red;

extern int RSI_Period = 14;
extern int Price = 0;

extern int Hist =1000;
 
double RSI_1[],RSI_2[],RSI_3[];


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

//----
   int init()
  {
  string short_name;
         short_name="3_RSI("+RSI_Period+")"+PAR_1+" "+PAR_2+" "+PAR_3;
         
     IndicatorShortName(short_name);
     IndicatorBuffers(3);

     SetIndexStyle(0,DRAW_LINE,3,2,Color_1);
     SetIndexStyle(1,DRAW_LINE,3,2,Color_2);  
     SetIndexStyle(2,DRAW_LINE,3,2,Color_3);  
      
     SetIndexLabel (0, PAR_1);
     SetIndexLabel (1, PAR_2);
     SetIndexLabel (2, PAR_3);
       
    if  (PAR_1!="")    SetIndexBuffer(0, RSI_1);
    if  (PAR_2!="")    SetIndexBuffer(1, RSI_2);
    if  (PAR_3!="")    SetIndexBuffer(2, RSI_3);
       
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   int i, limit, counted_bars=IndicatorCounted();   
   
  if(counted_bars < 0) 
      return(-1);
   if(counted_bars > 0) 
      counted_bars--;
   
   limit = Bars - counted_bars;
   
   if(Hist >= 0) 
      limit = Hist;

   for (i = limit; i>=0; i--)
   {  
   
  if  ( Mirroring_PAR_1) 
        RSI_1[i]=100-iRSI(PAR_1,0,RSI_Period,Price,i);
      else 
        RSI_1[i]=iRSI(PAR_1,0,RSI_Period,Price,i);
     
  if  ( Mirroring_PAR_2) 
        RSI_2[i]=100-iRSI(PAR_2,0,RSI_Period,Price,i);
      else
        RSI_2[i]=iRSI(PAR_2,0,RSI_Period,Price,i);
       
  if  ( Mirroring_PAR_3)     
        RSI_3[i]=100-iRSI(PAR_3,0,RSI_Period,Price,i);
      else  
        RSI_3[i]=iRSI(PAR_3,0,RSI_Period,Price,i);
  
 }  
  
//----
   return(0);
  }
//+------------------------------------------------------------------+